from tkinter import*
from tkinter.filedialog import askdirectory
from tkinter import StringVar
from tkinter import ttk
from tkinter import font
import tkinter as tk
import tkinter.messagebox
import webbrowser
import time
import pickle
import os
import sys
import tkinter.filedialog as filediag
import tkinter.simpledialog as simpledialog

root = tk.Tk()
root.title('Quick Jump SoftWare v1.0_alpha_1')
root.geometry('750x450')# 750,450
root.resizable(0,0)
#root.iconbitmap('assets/1.ico')
root.attributes("-alpha", 1) # 设置窗口透明度为80%

def open_url():
    webbrowser.open('https://www.bilibili.com/video/BV1GJ411x7h7') 
def open_url2():
    webbrowser.open('https://www.bilibili.com/')
def open_url3():
    webbrowser.open('https://zh.minecraft.wiki')
def open_url4():
    webbrowser.open('https://minecraft.net')
def open_url5():
    webbrowser.open('https://space.bilibili.com/3493136428960296')
def open_url6():
    webbrowser.open('https://www.bilibili.com/video/BV1CuyhYVE2h')
def open_url7():
    webbrowser.open('https://space.bilibili.com/1546229901')
def open_url8():
    webbrowser.open('https://www.mcmod.cn')
def open_url9():
    webbrowser.open('https://modrinth.com')
def open_url10():
    webbrowser.open('https://www.curseforge.com')
def open_url11():
    webbrowser.open('https://mc.163.com')
def open_url12():
    webbrowser.open('https://space.bilibili.com/697635368')
def open_url13():
    webbrowser.open('https://space.bilibili.com/5970160')
def open_url14():
    webbrowser.open('https://space.bilibili.com/178029850')
def open_url15():
    webbrowser.open('https://www.himcbbs.com')
    
def do_job():
    tkinter.messagebox.showerror(title='Sorry',message='「还未开发完成，请敬请期待」')
menubar=tk.Menu(root)
filemenu = tk.Menu(menubar,tearoff=0)
filemenu2 = tk.Menu(menubar,tearoff=0)
menubar.add_cascade(label='File',menu=filemenu)
filemenu.add_command(label='New', command=do_job,accelerator='Ctrl+N')
filemenu.add_command(label='Open', command=do_job,accelerator='Ctrl+O')
filemenu.add_command(label='Save', command=do_job,accelerator='Ctrl+S')
filemenu.add_separator()    # 添加一条分隔线

submenu = tk.Menu(filemenu,tearoff=0)

submenu.add_command(label='关于作者EnderPhantomWing', command=open_url5)

filemenu.add_command(label='『别看了，分隔线上边的都是摆设』')

filemenu.add_cascade(label='About', menu=submenu, underline=0)# 给放入的菜单submenu命名为Import

filemenu.add_command(label='Exit', command=root.quit,accelerator='Ctrl+Q')

def usr_log_in():
    usr_name=var_usr_name.get()
    usr_pwd=var_usr_pwd.get()
    try:
        with open('usr_info.pickle','rb') as usr_file:
            usrs_info=pickle.load(usr_file)
    except FileNotFoundError:
        with open('usr_info.pickle','wb') as usr_file:
            usrs_info={'admin':'admin'}
            pickle.dump(usrs_info,usr_file)
    if usr_name in usrs_info:
        if usr_pwd == usrs_info[usr_name]:
            tk.messagebox.showinfo(title='Welcome',message='Welcome：'+usr_name)
            btn1.config(state=tk.NORMAL)
            btn2.config(state=tk.NORMAL)
            btn3.config(state=tk.NORMAL)
            btn4.config(state=tk.NORMAL)
            btn5.config(state=tk.NORMAL)
            btn6.config(state=tk.NORMAL)
            btn7.config(state=tk.NORMAL)
            btn8.config(state=tk.NORMAL)
            btn9.config(state=tk.NORMAL)
            btn10.config(state=tk.NORMAL)
            btn11.config(state=tk.NORMAL)
            btn12.config(state=tk.NORMAL)
            btn13.config(state=tk.NORMAL)
        else:
            tk.messagebox.showerror(title='Error',message='Wrong Password')
    elif usr_name=='' or usr_pwd=='' :
        tk.messagebox.showerror(title='Error',message='The username or password is blank')
    #不在数据库中弹出是否注册的框
    else:
        is_signup=tk.messagebox.askyesno('Welcome','You have not registered yet, do you want to register now?')
        if is_signup:
            usr_sign_up()


def usr_sign_up():
    #确认注册时的相应函数
    def signtowcg():
        #获取输入框内的内容
        nn=new_name.get()
        np=new_pwd.get()
        npf=new_pwd_confirm.get()
 
        #本地加载已有用户信息,如果没有则已有用户信息为空
        try:
            with open('usr_info.pickle','rb') as usr_file:
                exist_usr_info=pickle.load(usr_file)
        except FileNotFoundError:
            exist_usr_info={}           
            
        #检查用户名存在、密码为空、密码前后不一致
        if nn in exist_usr_info:
            tk.messagebox.showerror('Error','The username already exists')
        elif np =='' or nn=='':
            tk.messagebox.showerror('Error','The username or password is blank')
        elif np !=npf:
            tk.messagebox.showerror('Error','The password is inconsistent')
        #注册信息没有问题则将用户名密码写入数据库
        else:
            exist_usr_info[nn]=np
            with open('usr_info.pickle','wb') as usr_file:
                pickle.dump(exist_usr_info,usr_file)
            tk.messagebox.showinfo('Welcome','Registration is successful!')
            #注册成功关闭注册框
            window_sign_up.destroy()
    #新建注册界面
    window_sign_up=tk.Toplevel(root)
    window_sign_up.geometry('370x200')
    window_sign_up.title('Registration page')
    #用户名变量及标签、输入框
    new_name=tk.StringVar()
    tk.Label(window_sign_up,text='Username：').place(x=10,y=10)
    tk.Entry(window_sign_up,textvariable=new_name).place(x=220,y=10)
    #密码变量及标签、输入框
    new_pwd=tk.StringVar()
    tk.Label(window_sign_up,text='Please enter your password：').place(x=10,y=50)
    tk.Entry(window_sign_up,textvariable=new_pwd,show='*').place(x=220,y=50)    
    #重复密码变量及标签、输入框
    new_pwd_confirm=tk.StringVar()
    tk.Label(window_sign_up,text='Please enter your password again：').place(x=10,y=90)
    tk.Entry(window_sign_up,textvariable=new_pwd_confirm,show='*').place(x=220,y=90)    
    #确认注册按钮及位置
    bt_confirm_sign_up=tk.Button(window_sign_up,text='Confirm your registration',
                                 command=signtowcg)
    bt_confirm_sign_up.place(x=100,y=130)

def selectPath():
    path_ = askdirectory() #使用askdirectory()方法返回文件夹的路径
    if path_ == "":
        path_.get() #当打开文件路径选择框后点击"取消" 输入框会清空路径，所以使用get()方法再获取一次路径
    else:
        path_ = path_.replace("/", "\\")  # 实际在代码中执行的路径为“\“ 所以替换一下
        path_.set(path_)


def openPath():
    dir = os.path.dirname(path.get()+"\\")
    os.system('start ' + dir)
    #print(dir)

def myfunction(event):
    canvas.configure(scrollregion=canvas.bbox("all"),width=200,height=200)


#画布区
canvas=Canvas(root)     # 创建画布
canvas.place(x=0,y=0,height=450,width=750)
canvas.config(highlightthickness=0)

#框架区
f1 = tk.Frame()#canvas,bg="white"
f1.place(x=0,y=30,width=750,height=450)
f3 = tk.Frame()#canvas,bg="white"
f3.place(x=0,y=30,width=750,height=450)

'''#滚动条
sb = tk.Scrollbar(canvas,orient=VERTICAL,command=canvas.yview)# HORIZONTAL
sb.place(x=750,y=0,anchor="ne",height=450)
canvas.configure(yscrollcommand=sb.set)

canvas.create_window((0,0),window=f1,anchor='nw')    # 要用create_window才能跟随画布滚动
f1.bind("<Configure>",myfunction)
'''
#多标签页区
notebook = tk.ttk.Notebook(canvas)
notebook.add(f1, text='跳转网站')

notebook.add(f3, text='请敬请期待，未开发完成')
notebook.place(x=0,y=0,width=750,height=450)

#文本框区
t1 = Text(f1,width=20,height=1,relief=FLAT)
t1.place(x=0,y=400)
t1.tag_configure('link', foreground='blue', underline=True)
t1.insert(END,'作者Bilibili个人主页\r\n','link')
t1.tag_bind('link', '<Button-1>', lambda evt: webbrowser.open('https://space.bilibili.com/3493136428960296'))

#按键区
btn1= tk.Button(f1,width=20, text='点我有惊喜',activeforeground='blue',command=open_url, state=tk.DISABLED)
btn1.place(x=0,y=155)
btn2= tk.Button(f1,width=20, text='Bilibili,启动！',activeforeground='blue', command=open_url2,state=tk.DISABLED)
btn2.place(x=0,y=95)
btn3= tk.Button(f1,width=20, text='MC Mod',activeforeground='blue', command=open_url8,state=tk.DISABLED)
btn3.place(x=160,y=95)
btn4= tk.Button(f1,width=20, text='Modrinth',activeforeground='blue', command=open_url9,state=tk.DISABLED)
btn4.place(x=160,y=125)
btn5= tk.Button(f1,width=20, text='CurseForge',activeforeground='blue', command=open_url10,state=tk.DISABLED)
btn5.place(x=160,y=155)
btn6= tk.Button(f1,width=20, text='MC Bug反馈/提交建议网站',activeforeground='blue', command=open_url11,state=tk.DISABLED)
btn6.place(x=160,y=245)
btn7=tk.Button(f1,width=20,text='MC Wiki 大中华区',activeforeground='blue',command=open_url3,state=tk.DISABLED)
btn7.place(x=160,y=185)
btn8=tk.Button(f1,width=20,text='Minecraft官网',activeforeground='blue',command=open_url4,state=tk.DISABLED)
btn8.place(x=160,y=215)
btn9=tk.Button(f1,width=20,text='作者の最新作品',
activeforeground='blue',command=open_url6,state=tk.NORMAL)
btn9.place(x=0,y=125)
btn10=tk.Button(f1,width=20,text='呱兄B站个人主页',activeforeground='blue',command=open_url12,state=tk.DISABLED)
btn10.place(x=0,y=185)
btn11=tk.Button(f1,width=20,text='小潮院长个人主页',activeforeground='blue',command=open_url13,state=tk.DISABLED)
btn11.place(x=0,y=215)
btn12=tk.Button(f1,width=20,text='杜海皇个人主页',activeforeground='blue',command=open_url14,state=tk.DISABLED)
btn12.place(x=0,y=245)
btn13=tk.Button(f1,width=20,text='HiMCBBS主站',activeforeground='blue',command=open_url15,state=tk.DISABLED)
btn13.place(x=460,y=0)
button = tk.Button(f1, text="Log in",activeforeground='red',state=tk.NORMAL,width=10,command=usr_log_in)
button.place(x=320,y=30)
button2 = tk.Button(f1, text="Sign up",activeforeground='red',state=tk.NORMAL,width=10,command=usr_sign_up)
button2.place(x=320,y=0)


#字
label=tk.Label(f1,text='Username:')
label.place(x=90,y=5)
label2=tk.Label(f1,text="Password:")
label2.place(x=90,y=35)
label3=tk.Label(f1,text="B站UP主推荐列表 ",width=20,font=("微软雅黑", 10,"bold"))
label3.place(x=0,y=65)
label4=tk.Label(f1,text="关于MC的一些网站",width=20,fg="red",font=("微软雅黑", 10,"bold"))
label4.place(x=150,y=65)
'''label5=tk.Label(f2,text="快捷启动常用软件",width=20,fg="blue",font=("微软雅黑", 10,"bold"))
label5.place(x=0,y=60)'''

#输入区
var_usr_name=tk.StringVar()
entry=tk.Entry(f1,textvariable=var_usr_name)
entry.place(x=160,y=5)

var_usr_pwd=tk.StringVar()
entry2=tk.Entry(f1,show="*",textvariable=var_usr_pwd)
entry2.place(x=160,y=35)


# 获取时间的函数
def gettime():
    # 获取当前时间
    dstr.set(time.strftime("%H:%M:%S"))
    # 每隔 1s 调用一次 gettime()函数来获取时间
    root.after(1000, gettime)
    root.update()
def gettime2():
    # 获取当前时间
    dstr2.set(time.strftime("%D"))
    # 每隔 1s 调用一次 gettime()函数来获取时间
    root.after(1000, gettime2)
    root.update()
# 生成动态字符串
dstr = StringVar()
dstr2 = StringVar()
# 利用 textvariable 来实现文本变化
label4 = tk.Label(f1, textvariable=dstr, fg='black', font=("微软雅黑", 12,"bold"))
label4.place(x=0,y=30)
label5 = tk.Label(f1, textvariable=dstr2, fg='black', font=("微软雅黑", 12,"bold"))
label5.place(x=0,y=0)
# 调用生成时间的函数
gettime()
gettime2()
# 显示窗口
'''
# 生成动态字符串
dstr3 = StringVar()
dstr4 = StringVar()
# 利用 textvariable 来实现文本变化
label10 = tk.Label(f2, textvariable=dstr, fg='black', font=("微软雅黑", 12,"bold"))
label10.place(x=0,y=30)
label11 = tk.Label(f2, textvariable=dstr2, fg='black', font=("微软雅黑", 12,"bold"))
label11.place(x=0,y=0)
# 调用生成时间的函数
gettime()
gettime2()
# 显示窗口
'''
# 生成动态字符串
dstr5 = StringVar()
dstr6 = StringVar()
# 利用 textvariable 来实现文本变化
label12 = tk.Label(f3, textvariable=dstr, fg='black', font=("微软雅黑", 12,"bold"))
label12.place(x=0,y=30)
label13 = tk.Label(f3, textvariable=dstr2, fg='black', font=("微软雅黑", 12,"bold"))
label13.place(x=0,y=0)
# 调用生成时间的函数
gettime()
gettime2()
# 显示窗口

root.config(menu=menubar)

root.mainloop()
